﻿using System;
using System.Linq;

namespace DemoCSharp8
{
    public class IndexAndRange
    {
        public IndexAndRange()
        {
            var array = new[] {
                'A', 'B', 'C', 'D', 'E', 'F', 'G',
                'H', 'I', 'L', 'M', 'N', 'O', 'P',
                'Q', 'R', 'S', 'T', 'U', 'V', 'Z'
            };

            IndexAndRangeFromArray(array);
            SpanFromArray(array);
        }

        public void IndexAndRangeFromArray(char[] array)
        {
            // ottenere l'ultimo elemento [Index]
            var l1 = array.Last();
            var l2 = array[^1];

            // ottenere tutta l'array [Range]
            var l3 = array[..];
            var l4 = array[Range.All];

            // ottenere tutti gli elementi ad esclusione del primo e dell'ultimo
            var l5 = array[1..^1];
            var l6 = array[new Range(1, 1)];

            // ottenere gli ultimi N elementi
            var l7 = array[^3..];
        }

        public void SpanFromArray(char[] array)
        {
            Span<char> span = array.AsSpan();

            // ottenere l'ultimo elemento
            Index i = ^1;
            var l1 = span.Slice(i.Value);

            // ottenere tutti gli elementi ad esclusione del primo e dell'ultimo
            Range r = 1..^1;
            var l2 = span.Slice(r.Start.Value, r.End.Value);
        }
    }
}