﻿using System.Collections.Generic;
using System.Linq;
using static System.Console;

namespace DemoCSharp8
{
    public class StaticLocalFunction
    {
        public StaticLocalFunction()
        {
            var numbers = Enumerable.Range(0, 20);
            var odds = GetOddNumbers(numbers);

            WriteLine($"I numeri pari sono: {string.Join(", ", odds)}");
        }

        private IEnumerable<int> GetOddNumbers(IEnumerable<int> numbers)
        {
            foreach (var number in numbers)
                if (IsOddNumber(number))
                    yield return number;

            static bool IsOddNumber(int n) => n % 2 == 0;
        }
    }
}