﻿using BenchmarkDotNet.Attributes;
using DemoCSharp8;

namespace PerformanceTests
{
    [MemoryDiagnoser]
    public class ReadFilePerformance
    {
        private readonly UsingDeclarations file = new UsingDeclarations();

        [Benchmark(Baseline = true)]
        public string Simple() => file.ReadFileContent();

        [Benchmark]
        public string WithBuffer() => file.ReadFileContentV3();

        [Benchmark]
        public string WithSlice() => file.ReadFileContentV4();
    }
}