﻿using System;

namespace DemoCSharp8
{
    partial class Program
    {
        static void Main(string[] args)
        {
            int option;

            do
            {
                option = ShowMenuAndOptions();

                switch (option)
                {
                    case 1:
                        _ = new NullableReferenceTypes();
                        break;

                    case 2:
                        _ = new DefaultInterfaceMembers(new Logger());
                        _ = new DefaultInterfaceMembers(new DefaultLogger());
                        break;

                    case 3:
                        _ = new ReadonlyMembers();
                        break;

                    case 4:
                        _ = new PatternMatching();
                        break;

                    case 5:
                        _ = new PropertyPattern();
                        break;

                    case 6:
                        _ = new UsingDeclarations();
                        break;

                    case 7:
                        _ = new StaticLocalFunction();
                        break;

                    case 8:
                        _ = new AsyncStream();
                        break;

                    case 9:
                        _ = new IndexAndRange();
                        break;

                    case 10:
                        _ = new JsonSerialization();
                        break;
                }

                Console.WriteLine(); 
            } while (option != -1);            
        }
    }
}