﻿using System;
using static System.Console;

namespace DemoCSharp8
{
    public class ReadonlyMembers
    {
        public ReadonlyMembers()
        {
            var point = new Point(1, 1);
            WriteLine(point);
        }
    }

    public struct Point
    {
        public double X { get; set; }
        public double Y { get; set; }

        public Point(double x, double y)
        {
            X = x;
            Y = y;
        }

        public readonly double Distance => Math.Sqrt(X* X + Y* Y);
        public readonly override string ToString() => $"({X}, {Y}) is {Distance} from origin";
    }
}